import { world, system } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';

/*Se não é seu, não roube. Peça permissão primeiramente. Ficarei feliz em compartilhar o que sei. Não copie e cole para tirar vantagem, como se fosse algo seu! Cada um merece ser credenciado pelo seu próprio esforço e trabalho!
If it's not yours, don't steal it. Ask for permission first. I'll be happy to share what I know. Don't copy and paste to take advantage as if it were your own! Everyone deserves to be credited for their own effort and work!
YouTube: @BoB13w*/

system.runTimeout(() => {
let total = world.scoreboard.getObjective("sTotal");
let jogador = world.scoreboard.getObjective("sJogador");
let cards = world.scoreboard.getObjective("sCard");
let color = world.scoreboard.getObjective("sColor");
let turno = world.scoreboard.getObjective("sTurno");
let fury = world.scoreboard.getObjective("sFury");
let creeper = world.scoreboard.getObjective("sCreeper");
let storm = world.scoreboard.getObjective("sStorm");
let fire = world.scoreboard.getObjective("sFire");
let mcard = world.scoreboard.getObjective("sMCard");
let timer = world.scoreboard.getObjective("sTimer");
let reves = world.scoreboard.getObjective("sReves");
let lang = world.scoreboard.getObjective("sLang");
let money = world.scoreboard.getObjective("sMoney");
let win = world.scoreboard.getObjective("sWin");
let vitt = world.scoreboard.getObjective("sVitt");
let derr = world.scoreboard.getObjective("sDerr");
const W = world.getDimension('overworld')

world.afterEvents.playerSpawn.subscribe((eventData) => {
    let { player, initialSpawn } = eventData;
    jogador.setScore(player, 0);
    total.setScore(player, 0);
    turno.setScore(player, 0);
    fury.setScore(player, 0);
    creeper.setScore(player, 0);
    storm.setScore(player, 0);
    fire.setScore(player, 0);
    mcard.setScore(player, 0);
    timer.addScore(player, 0);
    lang.addScore(player, 0);
    money.addScore(player, 0);
    win.setScore(player, 0);
    vitt.addScore(player, 0);
    derr.addScore(player, 0);
    player.runCommand("clear @s")
    player.removeTag("uunoo")
    player.removeTag("go")
});

function getS(target, objective) {
    try {
        const oB = world.scoreboard.getObjective(objective);
        if (typeof target == "string") return oB.getScore(oB.getParticipants().find((pT) => pT.displayName == target));
        return oB.getScore(target.scoreboardIdentity);
    } catch {
        return 0;
    }
};

function cardloj(player) {
    const ui = new ActionFormData()
    .title('§y§r')
    .body(` : ${getS(player, 'sMoney')}`)
    if (!player.hasTag("squadbloq")) {
        ui.button('§l 40', 'textures/items/squadbloq')
    } else {
        ui.button('', 'textures/items/squadbloq')
    }
    if (!player.hasTag("squadreverse")) {
        ui.button('§l 40', 'textures/items/squadreverse')
    } else {
        ui.button('', 'textures/items/squadreverse')
    }
    if (!player.hasTag("squadm2")) {
        ui.button('§l 40', 'textures/items/squadm2')
    } else {
        ui.button('', 'textures/items/squadm2')
    }
    if (!player.hasTag("squadm4")) {
        ui.button('§l 40', 'textures/items/squadm4')
    } else {
        ui.button('', 'textures/items/squadm4')
    }
    if (!player.hasTag("m6")) {
        ui.button('§l 20', 'textures/items/lojm6')
    } else if (!player.hasTag("squadm6")) {
        ui.button('§l 40', 'textures/items/squadm6')
    } else {
        ui.button('', 'textures/items/squadm6')
    }
    if (!player.hasTag("m8")) {
        ui.button('§l 20', 'textures/items/lojm8')
    } else if (!player.hasTag("squadm8")) {
        ui.button('§l 40', 'textures/items/squadm8')
    } else {
        ui.button('', 'textures/items/squadm8')
    }
    if (!player.hasTag("fury")) {
        ui.button('§l 20', 'textures/items/lojfury')
    } else if (!player.hasTag("squadfury")) {
        ui.button('§l 40', 'textures/items/squadfury')
    } else {
        ui.button('', 'textures/items/squadfury')
    }
    if (!player.hasTag("troll")) {
        ui.button('§l 50', 'textures/items/lojtroll')
    } else if (!player.hasTag("squadtroll")) {
        ui.button('§l 40', 'textures/items/squadtroll')
    } else {
        ui.button('', 'textures/items/squadtroll')
    }
    if (!player.hasTag("storm")) {
        ui.button('§l 20', 'textures/items/lojstorm')
    } else if (!player.hasTag("squadstorm")) {
        ui.button('§l 40', 'textures/items/squadstorm')
    } else {
        ui.button('', 'textures/items/squadstorm')
    }
    if (!player.hasTag("creeper")) {
        ui.button('§l 20', 'textures/items/lojcreeper')
    } else if (!player.hasTag("squadcreeper")) {
        ui.button('§l 40', 'textures/items/squadcreeper')
    } else {
        ui.button('', 'textures/items/squadcreeper')
    }
    if (!player.hasTag("fire")) {
        ui.button('§l 20', 'textures/items/lojfire')
    } else if (!player.hasTag("squadfire")) {
        ui.button('§l 40', 'textures/items/squadfire')
    } else {
        ui.button('', 'textures/items/squadfire')
    }
    if (!player.hasTag("life")) {
        ui.button('§l 20', 'textures/items/lojlife')
    } else if (!player.hasTag("squadlife")) {
        ui.button('§l 40', 'textures/items/squadlife')
    } else {
        ui.button('', 'textures/items/squadlife')
    }
    if (!player.hasTag("time")) {
        ui.button('§l 20', 'textures/items/lojtime')
    } else if (!player.hasTag("squadtime")) {
        ui.button('§l 40', 'textures/items/squadtime')
    } else {
        ui.button('', 'textures/items/squadtime')
    }
    if (!player.hasTag("squadbug")) {
        ui.button('§l 100', 'textures/items/squadbug')
    } else {
        ui.button('', 'textures/items/squadbug')
    }
    ui.show(player).then((option) => {
        switch (option.selection) {
            case 0:
                if (!player.hasTag("squadbloq") && money.getScore(player) >= 40) {
                    player.addTag("squadbloq")
                    money.addScore(player, -40)
                }
                break;
            case 1:
                if (!player.hasTag("squadreverse") && money.getScore(player) >= 40) {
                    player.addTag("squadreverse")
                    money.addScore(player, -40)
                }
                break;
            case 2:
                if (!player.hasTag("squadm2") && money.getScore(player) >= 40) {
                    player.addTag("squadm2")
                    money.addScore(player, -40)
                }
                break;
            case 3:
                if (!player.hasTag("squadm4") && money.getScore(player) >= 40) {
                    player.addTag("squadm4")
                    money.addScore(player, -40)
                }
                break;
            case 4:
                if (!player.hasTag("m6") && money.getScore(player) >= 20) {
                    player.addTag("m6")
                    money.addScore(player, -20)
                } else if (!player.hasTag("squadm6") && money.getScore(player) >= 40) {
                    player.addTag("squadm6")
                    money.addScore(player, -40)
                }
                break;
            case 5:
                if (!player.hasTag("m8") && money.getScore(player) >= 20) {
                    player.addTag("m8")
                    money.addScore(player, -20)
                } else if (!player.hasTag("squadm8") && money.getScore(player) >= 40) {
                    player.addTag("squadm8")
                    money.addScore(player, -40)
                }
                break;
            case 6:
                if (!player.hasTag("fury") && money.getScore(player) >= 20) {
                    player.addTag("fury")
                    money.addScore(player, -20)
                } else if (!player.hasTag("squadfury") && money.getScore(player) >= 40) {
                    player.addTag("squadfury")
                    money.addScore(player, -40)
                }
                break;
            case 7:
                if (!player.hasTag("troll") && money.getScore(player) >= 50) {
                    player.addTag("troll")
                    money.addScore(player, -50)
                } else if (!player.hasTag("squadtroll") && money.getScore(player) >= 40) {
                    player.addTag("squadtroll")
                    money.addScore(player, -40)
                }
                break;
            case 8:
                if (!player.hasTag("storm") && money.getScore(player) >= 20) {
                    player.addTag("storm")
                    money.addScore(player, -20)
                } else if (!player.hasTag("squadstorm") && money.getScore(player) >= 40) {
                    player.addTag("squadstorm")
                    money.addScore(player, -40)
                }
                break;
            case 9:
                if (!player.hasTag("creeper") && money.getScore(player) >= 20) {
                    player.addTag("creeper")
                    money.addScore(player, -20)
                } else if (!player.hasTag("squadcreeper") && money.getScore(player) >= 40) {
                    player.addTag("squadcreeper")
                    money.addScore(player, -40)
                }
                break;
            case 10:
                if (!player.hasTag("fire") && money.getScore(player) >= 20) {
                    player.addTag("fire")
                    money.addScore(player, -20)
                } else if (!player.hasTag("squadfire") && money.getScore(player) >= 40) {
                    player.addTag("squadfire")
                    money.addScore(player, -40)
                }
                break;
            case 11:
                if (!player.hasTag("life") && money.getScore(player) >= 20) {
                    player.addTag("life")
                    money.addScore(player, -20)
                } else if (!player.hasTag("squadlife") && money.getScore(player) >= 40) {
                    player.addTag("squadlife")
                    money.addScore(player, -40)
                }
                break;
            case 12:
                if (!player.hasTag("time") && money.getScore(player) >= 20) {
                    player.addTag("time")
                    money.addScore(player, -20)
                } else if (!player.hasTag("squadtime") && money.getScore(player) >= 40) {
                    player.addTag("squadtime")
                    money.addScore(player, -40)
                }
                break;
            case 13:
                if (!player.hasTag("squadbug") && money.getScore(player) >= 100) {
                    player.addTag("squadbug")
                    money.addScore(player, -100)
                }
                break;
        }
    })
};

const infoP = ["", "", "", "", "", "", "", "", ""];
function card(player) {
    const ui = new ActionFormData()
    .title('§y§r')
    .body(`§l: ${win.getScore(player)}     §eV§f: ${vitt.getScore(player)}     §cD§f: ${derr.getScore(player)}\n§l____________________`)
    .button('§lTutorial')
    if (lang.getScore(player) === 0) {
        ui.button('§lIdioma')
        ui.button('§l§cSair §fda Partida')
        if (jogador.getScore(player) === 1 && total.getScore(player) >= 2) {
            ui.button('§l§aIniciar §fPartida')
            ui.button('§lConfigurações')
        }
    }
    if (lang.getScore(player) === 1) {
        ui.button('§lLanguage')
        ui.button('§l§cExit §fGame')
        if (jogador.getScore(player) === 1 && total.getScore(player) >= 2) {
            ui.button('§l§aStart §fGame')
            ui.button('§lSettings')
        }
    }
    if (lang.getScore(player) === 2) {
        ui.button('§lIdioma')
        ui.button('§l§cSalir §fdel Juego')
        if (jogador.getScore(player) === 1 && total.getScore(player) >= 2) {
            ui.button('§l§aIniciar §fJuego')
            ui.button('§lConfiguraciones')
        }
    }
    ui.show(player).then((option) => {
        switch (option.selection) {
            case 0:
                player.runCommand("function tuto")
                break;
            case 1:
                cardlang(player)
                break;
            case 2:
                player.kill()
                break;
            case 3:
                if (total.getScore(player) >= 2) {
                    let jo = 1
                    let iniAle = Math.floor(Math.random() * 4);
                    player.runCommand(`scoreboard players set @e[type=b13:etuno] sCard ${iniAle}`)
                    player.runCommand(`scoreboard players set @e[type=b13:etuno] sColor ${iniAle}`)
                    player.runCommand("tag @e[type=b13:etuno] add on")
                    player.runCommand("scoreboard players set @e[type=b13:etuno] sTurno 1")
                    player.runCommand("execute at @e[type=b13:etuno] run playsound b14.unoini")
                    for (let i = 0; i < 7 * total.getScore(player); i++) {
                        let inic = selectRandomDamage(player);
                        player.runCommand(`give @a[scores={sJogador=${jo}}] ${inic} 1 0 {"minecraft:item_lock":{"mode": "lock_in_inventory"}}`)
                        if ((i + 1) % 7 === 0) {
                            jo++;
                            player.sendMessage(`${i + 1} `);
                        }
                    }
                }
                break;
            case 4:
                cardopt(player)
                break;
        }
    })
};

function cardlang(player) {
    const ui = new ActionFormData()
    .title('§y§r')
    if (lang.getScore(player) === 0) {
        ui.body('Selecione o Idioma')
    }
    if (lang.getScore(player) === 1) {
        ui.body('Select Language')
    }
    if (lang.getScore(player) === 2) {
        ui.body('Seleccione el Idioma')
    }
    ui.button('Português (BR)')
    ui.button('English')
    ui.button('Español')
    
    ui.show(player).then((option) => {
        switch (option.selection) {
            case 0:
                lang.setScore(player, 0)
                break;
            case 1: 
                lang.setScore(player, 1)
                break;
            case 2: 
                lang.setScore(player, 2)
                break;
        }
    })
};

let dBloq = "bloq", dRev = "reverse", dM2 = "m2", dM4 = "m4", dsquad = "squad";
let uSpecialC = 16;
let uWildC = 1;
let numberC = ["b13:red0", "b13:red1", "b13:red2", "b13:red3", "b13:red4", "b13:red5", "b13:red6", "b13:red7", "b13:red8", "b13:red9", "b13:blue0", "b13:blue1", "b13:blue2", "b13:blue3", "b13:blue4", "b13:blue5", "b13:blue6", "b13:blue7", "b13:blue8", "b13:blue9", "b13:green0", "b13:green1", "b13:green2", "b13:green3", "b13:green4", "b13:green5", "b13:green6", "b13:green7", "b13:green8", "b13:green9", "b13:yellow0", "b13:yellow1", "b13:yellow2", "b13:yellow3", "b13:yellow4", "b13:yellow5", "b13:yellow6", "b13:yellow7", "b13:yellow8", "b13:yellow9"];
let specialC = [`b13:red${dBloq}`, `b13:red${dRev}`, `b13:red${dM2}`, `b13:red${dM4}`, `b13:blue${dBloq}`, `b13:blue${dRev}`, `b13:blue${dM2}`, `b13:blue${dM4}`, `b13:green${dBloq}`, `b13:green${dRev}`, `b13:green${dM2}`, `b13:green${dM4}`, `b13:yellow${dBloq}`, `b13:yellow${dRev}`, `b13:yellow${dM2}`, `b13:yellow${dM4}`];
let wildC = [`b13:${dsquad}`];
let nr1 = 1, nr2 = 1, nr3 = 1, totalTimer = 30, minSlot = 0;
let danoV = numberC.concat(specialC, wildC);
function cardopt(player) {
    const ui = new ModalFormData()
    if (lang.getScore(player) === 0) {
        ui.title("Configurações do Jogo")
        ui.slider("Cartas Numeradas", 1, 10, 1, nr1)
        ui.slider("Cartas Especiais", 1, 10, 1, nr2)
        ui.slider("Cartas Coringas", 1, 20, 1, nr3)
        ui.slider("Tempo de Turno", 10, 60, 5, totalTimer)
        ui.slider("Slots Mínimos", 0, 26, 1, minSlot)
    }
    if (lang.getScore(player) === 1) {
        ui.title("Game Settings")
        ui.slider("Number Cards", 1, 10, 1, nr1)
        ui.slider("Special Cards", 1, 10, 1, nr2)
        ui.slider("Wild Cards", 1, 20, 1, nr3)
        ui.slider("Turn Time", 10, 60, 5, totalTimer)
        ui.slider("Minimum Slots", 0, 26, 1, minSlot)
    }
    if (lang.getScore(player) === 2) {
        ui.title("Configuración del Juego")
        ui.slider("Cartas Numeradas", 1, 10, 1, nr1)
        ui.slider("Cartas Especiales", 1, 10, 1, nr2)
        ui.slider("Cartas Comodín", 1, 20, 1, nr3)
        ui.slider("Tiempo por Turno", 10, 60, 5, totalTimer)
        ui.slider("Slots Mínimos", 0, 26, 1, minSlot)
    }
    ui.show(player).then((r) => {
        if (r.canceled) return
        const [r1, r2, r3, rt, rs] = r.formValues;
        uSpecialC = 16 * r2
        uWildC = 1 * r3
        danoV = Array(r1).fill(numberC).flat().concat(Array(r2).fill(specialC).flat()).concat(Array(r3).fill(wildC).flat());
        [nr1, nr2, nr3, totalTimer, minSlot] = [r1, r2, r3, rt, rs];
    })
};

let nnn;
const nn = [0, 1, 2, 3, 4, 5, 6, 7, 8];
world.beforeEvents.playerLeave.subscribe(({ player }) => {
    nn.forEach((interval, index) => {
        if (jogador.getScore(player) === index) {
            nnn = interval
        } else if (jogador.getScore(player) < 1) {
            nnn = undefined
        }
    })
});
    
world.afterEvents.playerLeave.subscribe(({ playerId, playerName }) => {
    for (const player4 of world.getAllPlayers()) {
        if (jogador.getScore(player4) > nnn) {
            jogador.addScore(player4, -1)
        }
    }
    if (nnn > 0) {
        const fPlayer = world.getAllPlayers()[0];
        fPlayer.runCommand("scoreboard players remove @e[type=b13:etuno] sTotal 1")
        fPlayer.runCommand("scoreboard players remove @e[type=b13:etuno] sJogador 1")
    }
});

world.afterEvents.entityDie.subscribe((die) => {
    let alvo = die.deadEntity;
    if (jogador.getScore(alvo) > 0) {
    derr.addScore(alvo, 1)
    }
    if (alvo.typeId === "minecraft:player" && jogador.getScore(alvo) > 0) {
        alvo.runCommand("scoreboard players remove @e[type=b13:etuno] sTotal 1");
        alvo.runCommand("scoreboard players remove @e[type=b13:etuno] sJogador 1");
        for (const player3 of world.getAllPlayers()) {
            if (player3.id !== alvo.id) {
                if (jogador.getScore(player3) > jogador.getScore(alvo)) {
                    jogador.addScore(player3, -1);
                }
            }
        }
    }
});

const jogadores = [1, 2, 3, 4, 5, 6, 7, 8];
world.afterEvents.entityHurt.subscribe((evt) => {
    let damager = evt.damageSource.damagingEntity;
    let alvo = evt.hurtEntity;
    if (alvo && damager && alvo.typeId === "minecraft:player" && damager.typeId === "minecraft:player") {
        damager.kill()
    }
    if (alvo && damager && alvo.typeId === "b13:etuno" && damager.typeId === "minecraft:player" && !alvo.hasTag("on") && total.getScore(damager) >= 1) {
        if (damager.isSneaking) {
            cardloj(damager)
        } else {
            card(damager)
        }
    }
    system.runTimeout(() => {
        jogadores.forEach((interval, index) => {
            if (alvo && damager && alvo.typeId === "b13:etuno" && damager.typeId === "minecraft:player" && !alvo.hasTag("on") && total.getScore(damager) === 0 && total.getScore(alvo) === index) {
                jogador.setScore(alvo, interval)
                system.runTimeout(() => jogador.setScore(damager, interval), 2)
                system.runTimeout(() => total.setScore(alvo, interval), 5)
            }
        })
    }, 5)
});

const mnick = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
const visual = ["", "", "", "", "", "", "", "", ""];
system.runInterval(() => {
    for (const player2 of world.getAllPlayers()) {
        visual.forEach((interval, index) => {
            mnick.forEach((minterval, mindex) => {
                if (jogador.getScore(player2) === index && mcard.getScore(player2) === mindex) {
                    if (win.getScore(player2) >= 1) {
                        player2.nameTag = `${win.getScore(player2)}${player2.name}${interval}\n${minterval}`
                    } else {
                        player2.nameTag = `${player2.name}${interval}\n${minterval}`
                    }
                }
            })
        })
        let inventory = player2.getComponent("minecraft:inventory").container;
        if (inventory.emptySlotsCount < minSlot + 1) {
            player2.kill()
        }
    }
}, 10)

let usedCards = {};
let uS = 0
let uW = 0
let vreves = 1
const cardbot = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
system.runInterval(() => {
    for (const entity2 of world.getDimension("overworld").getEntities()) {
        if (entity2.typeId === "b13:etuno") {
            cardbot.forEach((botInterval, botIndex) => {
            if (entity2.hasTag("on") && cards.getScore(entity2) === botIndex) {
                entity2.nameTag = `§l>> ${botInterval} <<`
                system.runTimeout(() => entity2.setProperty('b:unob', turno.getScore(entity2)), 2)
            }
            })
            infoP.forEach((Ninterval, Nindex) => {
                if(!entity2.hasTag("on") && total.getScore(entity2) === Nindex) {
                    entity2.nameTag = `${Ninterval}`
                }
            })
            if (total.getScore(entity2) === 0) {
                usedCards = {}
                uS = 0
                uW = 0
                vreves = 1
            }
            if (vreves === 1) {
                if (turno.getScore(entity2) > total.getScore(entity2)) {
                    turno.setScore(entity2, 1)
                }
            } else if (vreves === -1) {
                if (turno.getScore(entity2) < 1) {
                    turno.setScore(entity2, total.getScore(entity2))
                }
                if (turno.getScore(entity2) > total.getScore(entity2)) {
                    turno.addScore(entity2, -1)
                }
            }
            for (const player1 of world.getAllPlayers()) {
                let inventory = player1.getComponent("minecraft:inventory").container;
                const winCommand = () => {
                    jogador.setScore(player1, 0);
                    total.setScore(player1, 0);
                    turno.setScore(player1, 0);
                    fury.setScore(player1, 0);
                    creeper.setScore(player1, 0);
                    storm.setScore(player1, 0);
                    fire.setScore(player1, 0);
                    mcard.setScore(player1, 0);
                    system.runTimeout(() => player1.playSound('b14.unocoin'), 80)
                    money.addScore(player1, 10)
                    player1.runCommand("clear @s")
                    world.sendMessage(" @BoB13w")
                    if (player1.hasTag("guitar")) {
                        system.runTimeout(() => W.playSound('b14.unowing', {...player1.location}), 10)
                        system.runTimeout(() => player1.dimension.spawnParticle('b15.wing', {...player1.location}), 15)
                    } else {
                        system.runTimeout(() => W.playSound('b14.unowin', {...player1.location}), 10)
                        system.runTimeout(() => player1.dimension.spawnParticle('b15.win', {...player1.location}), 15)
                    }
                    win.addScore(player1, 1)
                    vitt.addScore(player1, 1)
                    system.runTimeout(() => entity2.remove(), 2)
                }
                if (entity2.hasTag("on") && total.getScore(player1) >= 1 && jogador.getScore(player1) === turno.getScore(entity2)) {
                    player1.addTag("go")
                } else {
                    player1.removeTag("go")
                    player1.removeTag("iuuno")
                    timer.setScore(player1, 0)
                }
                if (player1.hasTag("uunoo") && inventory.emptySlotsCount === 36) {
                    player1.runCommand(`kill @a[scores={sJogador=!${jogador.getScore(player1)},sTotal=1..}]`)
                    player1.removeTag("uunoo")
                    winCommand()
                }
                if (inventory.emptySlotsCount !== 35) {
                    player1.removeTag("uunoo")
                }
                if (player1.getComponent("minecraft:health").currentValue > 0 && player1.hasTag("go") && jogador.getScore(player1) === 1 && entity2.hasTag("on") && total.getScore(entity2) === 1) {
                    winCommand()
                }
            }
        }
        if (entity2 && (entity2.typeId === "b13:stru" || entity2.typeId === "b13:bcent")) {
            system.runTimeout(() => entity2.setProperty('b:unob', turno.getScore(entity2)), 2)
        }
    }
}, 1)

function selectRandomDamage(player) {
    const eRan = ["b", "r", "2", "4", "m6", "m8", "fury", "troll", "storm", "creeper", "fire", "life", "time"];
    let eRandom = eRan[Math.floor(Math.random() * eRan.length)];
    if (player.hasTag(`${eRandom}`)) {
        dBloq = dRev = dM2 = dM4 = eRandom
    } else {
        [dBloq, dRev, dM2, dM4] = ["bloq", "reverse", "m2", "m4"];
    }
    const cRan = ["squadbloq", "squadreverse", "squadm2", "squadm4", "squadm6", "squadm8", "squadfury", "squadtroll", "squadstorm", "squadcreeper", "squadfire", "squadlife", "squadtime", "squadbug", "s"];
    let cRandom = cRan[Math.floor(Math.random() * cRan.length)];
    if (player.hasTag(`${cRandom}`)) {
        dsquad = cRandom
    } else {
        dsquad = "squad"
    }
    if (uS >= uSpecialC) {
        specialC = [];
    } else {
        specialC = [`b13:red${dBloq}`, `b13:red${dRev}`, `b13:red${dM2}`, `b13:red${dM4}`, `b13:blue${dBloq}`, `b13:blue${dRev}`, `b13:blue${dM2}`, `b13:blue${dM4}`, `b13:green${dBloq}`, `b13:green${dRev}`, `b13:green${dM2}`, `b13:green${dM4}`, `b13:yellow${dBloq}`, `b13:yellow${dRev}`, `b13:yellow${dM2}`, `b13:yellow${dM4}`];
    }
    if (uW >= uWildC) {
        wildC = [];
    } else {
        wildC = [`b13:${dsquad}`];
    }
    danoV = Array(nr1).fill(numberC).flat().concat(Array(nr2).fill(specialC).flat()).concat(Array(nr3).fill(wildC).flat());
    danoV.forEach(dano => {
        if (!usedCards[dano]) {
            usedCards[dano] = 0;
        }
    })
    let availableDamages = danoV.filter(dano => usedCards[dano] < danoV.filter(d => d === dano).length);
    if (availableDamages.length === 0) {
        player.runCommand(`scoreboard players add @e[type=b13:etuno] sTurno ${vreves}`)
        if (lang.getScore(player) === 0) {
            player.sendMessage("Não há mais cartas!")
        }
        if (lang.getScore(player) === 1) {
            player.sendMessage("There are no more cards!")
        }
        if (lang.getScore(player) === 2) {
            player.sendMessage("¡No hay más cartas!")
        }
        world.sendMessage("")
        W.playSound('b14.unobloq', {...player.location})
        player.addEffect('instant_damage', 4, {amplifier: 1, showParticles: false})
        return null;
    }
    let randomIndex = Math.floor(Math.random() * availableDamages.length);
    let selectedDamage = availableDamages[randomIndex];
    usedCards[selectedDamage]++;
    
    if (specialC.includes(selectedDamage)) {
        uS++;
    }
    if (wildC.includes(selectedDamage)) {
        uW++;
    }
    return selectedDamage;
};

world.afterEvents.entityHurt.subscribe((evt) => {
    let damager = evt.damageSource.damagingEntity;
    let alvo = evt.hurtEntity;
    if (alvo.hasTag("on")) {
        if (total.getScore(damager) > 0 && jogador.getScore(damager) === turno.getScore(alvo)) {
            if (!damager.isSneaking) {
                let inter = selectRandomDamage(damager);
                if (fire.getScore(alvo) > 0) {
                let iint = Math.floor(Math.random() * 6) + 1;
                damager.setOnFire(iint, true)
                }
                if (fury.getScore(alvo) > 1) {
                    damager.applyDamage(fury.getScore(alvo))
                    damager.runCommand("camerashake add @a 0.3 0.3 rotational")
                    W.playSound('b14.bite', {...damager.location})
                    system.runTimeout(() => fury.setScore(alvo, 1), 2)
                }
                if (inter !== null) {
                    alvo.playAnimation('animation.etuno.hit' , {blendOutTime: 0.4})
                    W.playSound('b14.unocav', {...damager.location})
                    damager.runCommand(`give @s ${inter} 1 0 {"minecraft:item_lock":{"mode": "lock_in_inventory"}}`)
                    if (mcard.getScore(damager) > 0) {
                        mcard.addScore(damager, -1)
                    }
                }
            } else if (!damager.hasTag("iuuno") && damager.isSneaking && damager.getComponent("minecraft:inventory").container.emptySlotsCount === 34) {
                alvo.playAnimation('animation.etuno.hitwin' , {blendOutTime: 0.4})
                damager.addTag("iuuno")
                W.playSound('b14.uunoo', {...damager.location})
                alvo.dimension.spawnParticle('b15.uunoo', {...alvo.location})
            }
        }
    }
});

system.runInterval(() => {
    for (const playerr of world.getAllPlayers()) {
        if (playerr.hasTag("go")) {
            timer.addScore(playerr, 1)
        } else {
            timer.setScore(playerr, 0)
        }
        if (timer.getScore(playerr) === totalTimer - 5) {
            W.playSound('b14.time', {...playerr.location})
        }
        if (timer.getScore(playerr) > totalTimer) {
            playerr.addEffect('wither', 99999, {amplifier: 1, showParticles: false})
        } else {
            playerr.removeEffect("wither")
        }
    }
    for (const entity1 of world.getDimension("overworld").getEntities()) {
        if (entity1.typeId === "b13:etuno") {
            if (fire.getScore(entity1) > 0) {
                entity1.dimension.spawnParticle('minecraft:bleach', {...entity1.location});
            }
            if (storm.getScore(entity1) === 1) {
                world.setTimeOfDay(12000)
                world.getDimension("overworld").setWeather("Clear", 24000)
                W.playSound('break.tuff', {...entity1.location})
            }
            if (storm.getScore(entity1) === 2) {
                entity1.runCommand("execute at @a[tag=go] positioned ~~~ run summon lightning_bolt")
            }
            if (storm.getScore(entity1) > 0) {
                storm.addScore(entity1, -1)
            }
            if (fury.getScore(entity1) === 1) {
                fury.setScore(entity1, 0)
            }
            if (creeper.getScore(entity1) === 1) {
                entity1.runCommand(`execute at @a[tag=go] positioned ~~~ run playsound random.explode @a`)
                entity1.runCommand("execute at @a[tag=go] positioned ~~~ run particle minecraft:dragon_death_explosion_emitter")
                entity1.runCommand("damage @a[tag=go] 6")
            }
            if (creeper.getScore(entity1) > 0) {
                creeper.addScore(entity1, -1)
            }
        }
    }
}, 22);

const cardMap = {
    'b13:red0': { vCard: 0, vColor: 0 }, 'b13:blue0': { vCard: 1, vColor: 1 }, 'b13:green0': { vCard: 2, vColor: 2 }, 'b13:yellow0': { vCard: 3, vColor: 3 },
    'b13:red1': { vCard: 4, vColor: 0 }, 'b13:blue1': { vCard: 5, vColor: 1 }, 'b13:green1': { vCard: 6, vColor: 2 }, 'b13:yellow1': { vCard: 7, vColor: 3 },
    'b13:red2': { vCard: 8, vColor: 0 }, 'b13:blue2': { vCard: 9, vColor: 1 }, 'b13:green2': { vCard: 10, vColor: 2 }, 'b13:yellow2': { vCard: 11, vColor: 3 },
    'b13:red3': { vCard: 12, vColor: 0 }, 'b13:blue3': { vCard: 13, vColor: 1 }, 'b13:green3': { vCard: 14, vColor: 2 }, 'b13:yellow3': { vCard: 15, vColor: 3 },
    'b13:red4': { vCard: 16, vColor: 0 }, 'b13:blue4': { vCard: 17, vColor: 1 }, 'b13:green4': { vCard: 18, vColor: 2 }, 'b13:yellow4': { vCard: 19, vColor: 3 },
    'b13:red5': { vCard: 20, vColor: 0 }, 'b13:blue5': { vCard: 21, vColor: 1 }, 'b13:green5': { vCard: 22, vColor: 2 }, 'b13:yellow5': { vCard: 23, vColor: 3 },
    'b13:red6': { vCard: 24, vColor: 0 }, 'b13:blue6': { vCard: 25, vColor: 1 }, 'b13:green6': { vCard: 26, vColor: 2 }, 'b13:yellow6': { vCard: 27, vColor: 3 },
    'b13:red7': { vCard: 28, vColor: 0 }, 'b13:blue7': { vCard: 29, vColor: 1 }, 'b13:green7': { vCard: 30, vColor: 2 }, 'b13:yellow7': { vCard: 31, vColor: 3 },
    'b13:red8': { vCard: 32, vColor: 0 }, 'b13:blue8': { vCard: 33, vColor: 1 }, 'b13:green8': { vCard: 34, vColor: 2 }, 'b13:yellow8': { vCard: 35, vColor: 3 },
    'b13:red9': { vCard: 36, vColor: 0 }, 'b13:blue9': { vCard: 37, vColor: 1 }, 'b13:green9': { vCard: 38, vColor: 2 }, 'b13:yellow9': { vCard: 39, vColor: 3 },
    'b13:redbloq': { vCard: 40, vColor: 0 }, 'b13:bluebloq': { vCard: 41, vColor: 1 }, 'b13:greenbloq': { vCard: 42, vColor: 2 }, 'b13:yellowbloq': { vCard: 43, vColor: 3 },
    'b13:redreverse': { vCard: 44, vColor: 0 }, 'b13:bluereverse': { vCard: 45, vColor: 1 }, 'b13:greenreverse': { vCard: 46, vColor: 2 }, 'b13:yellowreverse': { vCard: 47, vColor: 3 },
    'b13:redm2': { vCard: 48, vColor: 0 }, 'b13:bluem2': { vCard: 49, vColor: 1 }, 'b13:greenm2': { vCard: 50, vColor: 2 }, 'b13:yellowm2': { vCard: 51, vColor: 3 },
    'b13:redm4': { vCard: 52, vColor: 0 }, 'b13:bluem4': { vCard: 53, vColor: 1 }, 'b13:greenm4': { vCard: 54, vColor: 2 }, 'b13:yellowm4': { vCard: 55, vColor: 3 },
    'b13:redm6': { vCard: 56, vColor: 0 }, 'b13:bluem6': { vCard: 57, vColor: 1 }, 'b13:greenm6': { vCard: 58, vColor: 2 }, 'b13:yellowm6': { vCard: 59, vColor: 3 },
    'b13:redm8': { vCard: 60, vColor: 0 }, 'b13:bluem8': { vCard: 61, vColor: 1 }, 'b13:greenm8': { vCard: 62, vColor: 2 }, 'b13:yellowm8': { vCard: 63, vColor: 3 },
    'b13:redfury': { vCard: 64, vColor: 0 }, 'b13:bluefury': { vCard: 65, vColor: 1 }, 'b13:greenfury': { vCard: 66, vColor: 2 }, 'b13:yellowfury': { vCard: 67, vColor: 3 },
    'b13:redtroll': { vCard: 68, vColor: 0 }, 'b13:bluetroll': { vCard: 69, vColor: 1 }, 'b13:greentroll': { vCard: 70, vColor: 2 }, 'b13:yellowtroll': { vCard: 71, vColor: 3 },
    'b13:redstorm': { vCard: 72, vColor: 0 }, 'b13:bluestorm': { vCard: 73, vColor: 1 }, 'b13:greenstorm': { vCard: 74, vColor: 2 }, 'b13:yellowstorm': { vCard: 75, vColor: 3 },
    'b13:redcreeper': { vCard: 76, vColor: 0 }, 'b13:bluecreeper': { vCard: 77, vColor: 1 }, 'b13:greencreeper': { vCard: 78, vColor: 2 }, 'b13:yellowcreeper': { vCard: 79, vColor: 3 },
    'b13:redfire': { vCard: 80, vColor: 0 }, 'b13:bluefire': { vCard: 81, vColor: 1 }, 'b13:greenfire': { vCard: 82, vColor: 2 }, 'b13:yellowfire': { vCard: 83, vColor: 3 },
    'b13:redlife': { vCard: 84, vColor: 0 }, 'b13:bluelife': { vCard: 85, vColor: 1 }, 'b13:greenlife': { vCard: 86, vColor: 2 }, 'b13:yellowlife': { vCard: 87, vColor: 3 },
    'b13:redtime': { vCard: 88, vColor: 0 }, 'b13:bluetime': { vCard: 89, vColor: 1 }, 'b13:greentime': { vCard: 90, vColor: 2 }, 'b13:yellowtime': { vCard: 91, vColor: 3 },
    'b13:squadbloq': { rCard: 40, bCard: 41, gCard: 42, yCard: 43 },
    'b13:squadreverse': { rCard: 44, bCard: 45, gCard: 46, yCard: 47 },
    'b13:squadm2': { rCard: 48, bCard: 49, gCard: 50, yCard: 51 },
    'b13:squadm4': { rCard: 52, bCard: 53, gCard: 54, yCard: 55 },
    'b13:squadm6': { rCard: 56, bCard: 57, gCard: 58, yCard: 59 },
    'b13:squadm8': { rCard: 60, bCard: 61, gCard: 62, yCard: 63 },
    'b13:squadfury': { rCard: 64, bCard: 65, gCard: 66, yCard: 67 },
    'b13:squadtroll': { rCard: 68, bCard: 69, gCard: 70, yCard: 71 },
    'b13:squadstorm': { rCard: 72, bCard: 73, gCard: 74, yCard: 75 },
    'b13:squadcreeper': { rCard: 76, bCard: 77, gCard: 78, yCard: 79 },
    'b13:squadfire': { rCard: 80, bCard: 81, gCard: 82, yCard: 83 },
    'b13:squadlife': { rCard: 84, bCard: 85, gCard: 86, yCard: 87 },
    'b13:squadtime': { rCard: 88, bCard: 89, gCard: 90, yCard: 91 },
    'b13:squadbug': { rCard: 92, bCard: 93, gCard: 94, yCard: 95 },
    'b13:squad': { rCard: 96, bCard: 97, gCard: 98, yCard: 99 }
};

world.beforeEvents.itemUse.subscribe((data) => {
    system.run(() => {
        let player = data.source;
        let item = data.itemStack?.typeId;
        for (const entiEtuno of world.getDimension("overworld").getEntities()) {
            if (entiEtuno.typeId === "b13:etuno" && (mcard.getScore(player) < 1 || item.includes("time")) && player.hasTag("go") && cardMap[item]) {
                let card = cardMap[item];
                let vCard = card.vCard;
                let vColor = card.vColor;
                
                const CardCommand = () => {
                    let bugb = 0
                    if (item.includes("bug")) {
                        bugb = 1
                        W.playSound('b14.unobug', {...entiEtuno.location})
                        const buRan = ["bloq", "reverse", "m2", "m4", "m6", "m8", "fury", "troll", "storm", "creeper", "fire", "life", "time"];
                        let inbu = buRan[Math.floor(Math.random() * buRan.length)];
                        item = item.replace('bug', inbu);
                    }
                    if (item.includes("time")) {
                        reves.setScore(entiEtuno, 0)
                        fury.setScore(entiEtuno, 0)
                        storm.setScore(entiEtuno, 0)
                        creeper.setScore(entiEtuno, 0)
                        fire.setScore(entiEtuno, 0)
                        mcard.setScore(player, 0)
                        money.addScore(player, 2)
                        system.runTimeout(() => player.playSound('b14.unocoin'), 30)
                    }
                    if (item.includes("troll")) {
                        W.playSound('b14.troll', {...entiEtuno.location})
                    }
                    if (item.includes("reverse")) {
                        W.playSound('b14.reverse', {...entiEtuno.location})
                        if (vreves === 1) {
                            vreves = -1
                        } else if (vreves === -1) {
                            vreves = 1
                        }
                        if (total.getScore(player) === 2) {
                            turno.addScore(entiEtuno, vreves)
                        }
                    }
                    cards.setScore(entiEtuno, vCard)
                    color.setScore(entiEtuno, vColor)
                    system.runTimeout(() => turno.addScore(entiEtuno, vreves), 1)
                    W.playSound('b14.unocav', {...player.location})
                    if (item.includes("fury")) {
                        fury.addScore(entiEtuno, 2)
                        W.playSound('b14.fury', {...entiEtuno.location})
                    }
                    if (fury.getScore(entiEtuno) > 1) {
                        fury.addScore(entiEtuno, 1)
                        W.playSound('break.tuff', {...entiEtuno.location})
                    }
                    if (item.includes("bloq")) {
                        W.playSound('b14.unobloq', {...entiEtuno.location})
                        system.runTimeout(() => entiEtuno.runCommand("execute at @a[tag=go] positioned ~~~ run particle b15.bloq ^^0.2^0.5"), 2)
                        system.runTimeout(() => turno.addScore(entiEtuno, vreves), 3)
                    }
                    if (item.includes("m2")){
                        system.runTimeout(() => W.playSound('b14.ups', {...entiEtuno.location}), 20)
                        system.runTimeout(() => entiEtuno.runCommand("scoreboard players add @a[tag=go] sMCard 2"), 20)
                    }
                    if (item.includes("m4")){
                        system.runTimeout(() => W.playSound('b14.ups', {...entiEtuno.location}), 20)
                        system.runTimeout(() => entiEtuno.runCommand("scoreboard players add @a[tag=go] sMCard 4"), 20)
                    }
                    if (item.includes("m6")){
                        system.runTimeout(() => W.playSound('b14.ups', {...entiEtuno.location}), 20)
                        system.runTimeout(() => entiEtuno.runCommand("scoreboard players add @a[tag=go] sMCard 6"), 20)
                    }
                    if (item.includes("m8")){
                        system.runTimeout(() => W.playSound('b14.ups', {...entiEtuno.location}), 20)
                        system.runTimeout(() => entiEtuno.runCommand("scoreboard players add @a[tag=go] sMCard 8"), 20)
                    }
                    if (item.includes("storm")) {
                        if (storm.getScore(entiEtuno) > 1) {
                            storm.setScore(entiEtuno, 1)
                            W.playSound('ambient.weather.thunder', {...entiEtuno.location})
                        } else {
                            storm.setScore(entiEtuno, 10)
                            world.getDimension("overworld").setWeather("Thunder", 24000)
                            W.playSound('break.tuff', {...entiEtuno.location})
                            world.setTimeOfDay(18000)
                        }
                    }
                    if (storm.getScore(entiEtuno) > 1) {
                        storm.setScore(entiEtuno, 10)
                        W.playSound('break.tuff', {...entiEtuno.location})
                    }
                    if (item.includes("creeper")) {
                        creeper.setScore(entiEtuno, 12)
                        W.playSound('mob.creeper.say', {...entiEtuno.location})
                    }
                    if (creeper.getScore(entiEtuno) > 0) {
                        let intvc = Math.floor(Math.random() * 13);
                        creeper.setScore(entiEtuno, intvc)
                        if (intvc === 0) {
                            W.playSound('mob.creeper.death', {...entiEtuno.location})
                        }
                    }
                    if (item.includes("life")) {
                        const regSk = [100, 160, 260, 360];
                        let intv = regSk[Math.floor(Math.random() * regSk.length)];
                        player.addEffect('regeneration', intv, {amplifier: 1, showParticles: false})
                    }
                    if (item.includes("fire")) {
                        if (fire.getScore(entiEtuno) > 0) {
                            fire.setScore(entiEtuno, 0)
                            W.playSound('fire.fire', {...entiEtuno.location})
                        } else {
                            fire.setScore(entiEtuno, 1)
                            W.playSound('block.blastfurnace.fire_crackle', {...entiEtuno.location})
                        }
                    }
                    if (bugb === 1) {
                        player.runCommand("clear @s b13:squadbug 0 1")
                    } else {
                        player.runCommand(`clear @s ${item} 0 1`)
                    }
                    if (player.hasTag("iuuno")) {
                        player.addTag("uunoo")
                    }
                }
                
                if (item.includes("squad")) {
                    const ui = new ActionFormData()
                    .title('§g§r')
                    if (lang.getScore(player) === 0) {
                    ui.body('Escolha uma Cor')
                    }
                    if (lang.getScore(player) === 1) {
                    ui.body('Choose a Color')
                    }
                    if (lang.getScore(player) === 2) {
                    ui.body('Elige un Color')
                    }
                    ui.button('', 'textures/unohud/redcolor')
                    ui.button('', 'textures/unohud/bluecolor')
                    ui.button('', 'textures/unohud/greencolor')
                    ui.button('', 'textures/unohud/yellowcolor')
                    
                    ui.show(player).then((option) => {
                        switch (option.selection) {
                            case 0:
                                vCard = card.rCard
                                vColor = 0
                                CardCommand()
                                break;
                            case 1: 
                                vCard = card.bCard
                                vColor = 1
                                CardCommand()
                                break;
                            case 2: 
                                vCard = card.gCard
                                vColor = 2
                                CardCommand()
                                break;
                            case 3:
                                vCard = card.yCard
                                vColor = 3
                                CardCommand()
                                break;
                        }
                    })
                } else if (cards.getScore(entiEtuno) >= Math.floor(vCard / 4) * 4 && cards.getScore(entiEtuno) <= Math.floor(vCard / 4) * 4 + 3) {
                    CardCommand()
                } else if (color.getScore(entiEtuno) === vColor) {
                    CardCommand()
                } else {
                    player.runCommand("title @s[tag=go] actionbar ")
                    player.playSound('b14.unobloq')
                }
            }
        }
    })
})
}, 20)